

!!! Listing 1: Identisches Ergebnis

<!-- erste Defintion -->
<xsl:variable name="node-set" select="expression"/>
<xsl:for-each select="$node-set ">
	... Gesamtanzahl <xsl:value-of select="count($node-set)"/>
</xsl:for-each>

<!-- zweite Defintion -->
<xsl:variable name="node-set" select="expression"/>
<xsl:variable name="summe" select="count($node-set)"/>
<xsl:for-each select="$node-set ">
	... Gesamtanzahl <xsl:value-of select="$summe"/>
</xsl:for-each>

!!! Listing 2: authorfee.xml 

<payment-list>
      <line>
         <author>GOULD</author>
         <fee>5.5</fee>
      </line>
      <line>
         <author>TYAGI</author>
         <fee>8.3</fee>
      </line>
      <line>
         <author>LI</author>
         <fee>2.11</fee>
      </line>
      <line>
         <author>GOULD</author>
         <fee>7.4</fee>
      </line>
      ...
 <payment-list/>

!!! Listing 3: GroupByXPath.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns="http://www.w3.org/TR/REC-html40">
  <xsl:key name="fee-by-author" match="fee" use="../author"/>
  <xsl:template match="payment-list">
    <xsl:for-each select="line[not(author = preceding-sibling::line/author)]" >
      <xsl:variable name="author" select="author" />
      <xsl:variable name="fee" select="key('fee-by-author',$author)"/>
      <xsl:text>
      </xsl:text>
      <xsl:value-of select="$author"/> : 
      <xsl:value-of select="format-number(sum($fee), '#.00')"/>
    </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>

!!! Listing 4: GroupByKeys.xsl

<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns="http://www.w3.org/TR/REC-html40">
  <xsl:key name="author-index" match="line" use="author"/>
  <xsl:key name="fee-by-author" match="fee" use="../author"/>
  <xsl:template match="payment-list">
    <xsl:for-each select="line[count(. | key('author-index', author)[1]) = 1]">
      <xsl:variable name="author" select="author" />
        <xsl:variable name="fee" select="key('fee-by-author',$author)"/>
        <xsl:text>
        </xsl:text>
        <xsl:value-of select="$author" /> : 
        <xsl:value-of select="format-number(sum($fee), '#.00')"/>
     </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>
